#include <stdlib.h>

#include "gba.h"
#include "gbalib.h"
#include "sworld3.h"

extern const Sprite sprite_off;
extern const Sprite sprite_clean;
extern player_t player;

extern u8 num_misc_actors;
extern misc_actor_t misc_actor [max_misc_actors];

void misc_actor_kill (u8 actor_num)
{
  u8 replace = num_misc_actors -1;
 
  if (actor_num < replace)
  {
    misc_actor[actor_num] = misc_actor[replace];
  }

  misc_actor[replace].sprite = sprite_off;
  num_misc_actors --;

}

void create_misc_sparkle (u16 x, u16 y)
{
  u8 c = num_misc_actors;
  if (num_misc_actors < max_misc_actors)
  {
    misc_actor[c].x = x;
    misc_actor[c].y = y;
    misc_actor[c].count = 6;
    misc_actor[c].sprite = sprite_clean;
    if (y&16)
    {
      sprite_tile(&misc_actor[c].sprite,38);
    }
    else
    {
      sprite_tile(&misc_actor[c].sprite,39);
    }

    misc_actor[c].type = misc_sparkle;

    sprite_size(&misc_actor[c].sprite,0);
    sprite_shape(&misc_actor[c].sprite,0);
    sprite_move (&misc_actor[c].sprite, misc_actor[c].x>>4, misc_actor[c].y>>4);
    
    num_misc_actors++;
  }

}

u8 misc_sparkle_turn (u8 actor_num)
{
  misc_actor[actor_num].count --;

  if (misc_actor[actor_num].count == 0)
  {
    misc_actor_kill (actor_num);
    return 0;
  }
  
  return 1;
}



void create_misc_explosion (u16 x, u16 y)
{
  u8 c = num_misc_actors;
  if (num_misc_actors < max_misc_actors)
  {
    misc_actor[c].x = x;
    misc_actor[c].y = y;
    misc_actor[c].count = 10;
    misc_actor[c].type = misc_explosion;

    misc_actor[c].sprite = sprite_clean;
    sprite_size(&misc_actor[c].sprite,1);
    sprite_shape(&misc_actor[c].sprite,0);
    sprite_tile(&misc_actor[c].sprite,64);
    sprite_move (&misc_actor[c].sprite, misc_actor[c].x>>4, misc_actor[c].y>>4);
    
    num_misc_actors++;
  }

}

const u8 misc_explosion_tile [] = {72,72,70,70,68,68,66,66,64,64,64};
u8 misc_explosion_turn (u8 actor_num)
{
  misc_actor[actor_num].count --;

  sprite_tile(&misc_actor[actor_num].sprite,
    misc_explosion_tile[misc_actor[actor_num].count]);

  if (misc_actor[actor_num].count == 0)
  {
    misc_actor_kill (actor_num);
    return 0;
  }
  else
    return 1;
}



u8 misc_actors_turn (u8 actor_num)
{
  if (misc_actor[actor_num].type == misc_explosion)
    return misc_explosion_turn (actor_num);

  if (misc_actor[actor_num].type == misc_sparkle)
    return misc_sparkle_turn (actor_num);

  return 1;
}

